"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _rax = require("rax");

var _raxView = _interopRequireDefault(require("rax-view"));

var _raxText = _interopRequireDefault(require("rax-text"));

var _raxTouchable = _interopRequireDefault(require("rax-touchable"));

var _styles = _interopRequireDefault(require("./styles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Day =
/*#__PURE__*/
function (_Component) {
  _inherits(Day, _Component);

  function Day() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Day);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Day)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "dayCircleStyle", function (isWeekend, isSelected, isToday) {
      var customStyle = _this.props.customStyle;
      var dayCircleStyle = [_styles.default.dayCircleFiller, customStyle.dayCircleFiller && customStyle.dayCircleFiller];

      if (isSelected && !isToday) {
        dayCircleStyle.push(_styles.default.selectedDayCircle, customStyle.selectedDayCircle && customStyle.selectedDayCircle);
      } else if (isSelected && isToday) {
        dayCircleStyle.push(_styles.default.currentDayCircle, customStyle.currentDayCircle && customStyle.currentDayCircle);
      }

      return dayCircleStyle;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "dayTextStyle", function (isWeekend, isSelected, isToday, isDisabled) {
      var customStyle = _this.props.customStyle;
      var dayTextStyle = [_styles.default.day, customStyle.day];

      if (isDisabled) {
        dayTextStyle.push(_styles.default.disabledDayText, customStyle.disabledDayText && customStyle.disabledDayText);
      } else if (isToday && !isSelected) {
        dayTextStyle.push(_styles.default.currentDayText, customStyle.currentDayText && customStyle.currentDayText);
      } else if (isToday || isSelected) {
        dayTextStyle.push(_styles.default.selectedDayText, customStyle.selectedDayText && customStyle.selectedDayText);
      } else if (isWeekend) {
        dayTextStyle.push(_styles.default.weekendDayText, customStyle.weekendDayText && customStyle.weekendDayText);
      }

      return dayTextStyle;
    });

    return _this;
  }

  _createClass(Day, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          caption = _this$props.caption,
          customStyle = _this$props.customStyle;
      var _this$props2 = this.props,
          filler = _this$props2.filler,
          hasEvent = _this$props2.hasEvent,
          isWeekend = _this$props2.isWeekend,
          isSelected = _this$props2.isSelected,
          isToday = _this$props2.isToday,
          isDisabled = _this$props2.isDisabled,
          usingEvents = _this$props2.usingEvents;
      return filler ? (0, _rax.createElement)(_raxTouchable.default, null, (0, _rax.createElement)(_raxView.default, {
        style: [_styles.default.dayButtonFiller, customStyle.dayButtonFiller]
      }, (0, _rax.createElement)(_raxText.default, {
        style: [_styles.default.day, customStyle.day]
      }))) : (0, _rax.createElement)(_raxTouchable.default, {
        onPress: isDisabled ? null : this.props.onPress
      }, (0, _rax.createElement)(_raxView.default, {
        style: [_styles.default.dayButton, customStyle.dayButton]
      }, (0, _rax.createElement)(_raxView.default, {
        style: this.dayCircleStyle(isWeekend, isSelected, isToday)
      }, (0, _rax.createElement)(_raxText.default, {
        style: this.dayTextStyle(isWeekend, isSelected, isToday, isDisabled)
      }, caption)), usingEvents && (0, _rax.createElement)(_raxView.default, {
        style: [_styles.default.eventIndicatorFiller, customStyle.eventIndicatorFiller, hasEvent && _styles.default.eventIndicator, hasEvent && customStyle.eventIndicator]
      })));
    }
  }]);

  return Day;
}(_rax.Component);

exports.default = Day;

_defineProperty(Day, "defaultProps", {
  customStyle: {}
});

_defineProperty(Day, "propTypes", {
  caption: _rax.PropTypes.any,
  customStyle: _rax.PropTypes.object,
  filler: _rax.PropTypes.bool,
  hasEvent: _rax.PropTypes.bool,
  isSelected: _rax.PropTypes.bool,
  isToday: _rax.PropTypes.bool,
  isWeekend: _rax.PropTypes.bool,
  isDisabled: _rax.PropTypes.bool,
  onPress: _rax.PropTypes.func,
  usingEvents: _rax.PropTypes.bool
});

module.exports = exports["default"];