"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _rax = require("rax");

var _raxView = _interopRequireDefault(require("rax-view"));

var _raxText = _interopRequireDefault(require("rax-text"));

var _raxTouchable = _interopRequireDefault(require("rax-touchable"));

var _Day = _interopRequireDefault(require("./Day"));

var _moment = _interopRequireDefault(require("./moment"));

var _styles = _interopRequireDefault(require("./styles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DEVICE_WIDTH = 750;
var VIEW_INDEX = 2;

var Calendar =
/*#__PURE__*/
function (_Component) {
  _inherits(Calendar, _Component);

  function Calendar() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Calendar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Calendar)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      currentMonthMoment: (0, _moment.default)(_this.props.selectedDate || _this.props.startDate || _this.props.endDate || _this.props.today),
      selectedMoment: (0, _moment.default)(_this.props.selectedDate)
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onPrev", function () {
      var newMoment = (0, _moment.default)(_this.state.currentMonthMoment).addMonth(-1);

      _this.setState({
        currentMonthMoment: newMoment
      });

      _this.props.onTouchPrev && _this.props.onTouchPrev(newMoment);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onNext", function () {
      var newMoment = (0, _moment.default)(_this.state.currentMonthMoment).addMonth(1);

      _this.setState({
        currentMonthMoment: newMoment
      });

      _this.props.onTouchNext && _this.props.onTouchNext(newMoment);
    });

    return _this;
  }

  _createClass(Calendar, [{
    key: "getMonthStack",
    value: function getMonthStack(currentMonth) {
      return [(0, _moment.default)(currentMonth)];
    }
  }, {
    key: "prepareEventDates",
    value: function prepareEventDates(eventDates) {
      var parsedDates = {};
      eventDates.forEach(function (event) {
        var date = (0, _moment.default)(event);
        var month = (0, _moment.default)(date).startOfMonth().format();

        if (!parsedDates[month]) {
          parsedDates[month] = {};
        }

        parsedDates[month][date.date() - 1] = true;
      });
      return parsedDates;
    }
  }, {
    key: "selectDate",
    value: function selectDate(date) {
      this.setState({
        selectedMoment: date
      });
      this.props.onDateSelect && this.props.onDateSelect(date.format(this.props.dateFormat));
    }
  }, {
    key: "renderMonthView",
    value: function renderMonthView(argMoment, eventDatesMap) {
      var _this2 = this;

      var renderIndex = 0,
          weekRows = [],
          days = [],
          startOfArgMonthMoment = argMoment.startOfMonth();
      var selectedMoment = (0, _moment.default)(this.state.selectedMoment),
          weekStart = this.props.weekStart,
          todayMoment = (0, _moment.default)(this.props.today),
          todayIndex = todayMoment.date() - 1,
          argMonthDaysCount = argMoment.daysInMonth(),
          offset = (startOfArgMonthMoment.isoWeekday() - weekStart + 7) % 7,
          argMonthIsToday = argMoment.isSameMonth(todayMoment),
          selectedIndex = (0, _moment.default)(selectedMoment).date() - 1,
          selectedMonthIsArg = selectedMoment.isSameMonth(argMoment),
          startMoment = this.props.startDate && (0, _moment.default)(this.props.startDate),
          endMoment = this.props.endDate && (0, _moment.default)(this.props.endDate);
      var events = eventDatesMap !== null ? eventDatesMap[argMoment.startOfMonth().format()] : null;

      if (!argMoment.isValid()) {
        console.error('[currentMonthMoment] is not valid, make sure [selectedDate startDate endDate today] are valid date');
        return null;
      }

      var _loop = function _loop() {
        var dayIndex = renderIndex - offset;
        var isoWeekday = (renderIndex + weekStart) % 7;
        var date = (0, _moment.default)(startOfArgMonthMoment).setDate(dayIndex + 1);
        var isDisabled = startMoment && date.getTime() < startMoment.getTime() || endMoment && date.getTime() > endMoment.getTime();

        if (dayIndex >= 0 && dayIndex < argMonthDaysCount) {
          days.push((0, _rax.createElement)(_Day.default, {
            startOfMonth: startOfArgMonthMoment,
            isWeekend: isoWeekday === 0 || isoWeekday === 6,
            key: "".concat(renderIndex),
            onPress: function onPress() {
              _this2.selectDate(date);
            },
            caption: "".concat(dayIndex + 1),
            isToday: argMonthIsToday && dayIndex === todayIndex,
            isSelected: selectedMonthIsArg && dayIndex === selectedIndex,
            hasEvent: events && events[dayIndex] === true,
            usingEvents: _this2.props.eventDates.length > 0,
            customStyle: _this2.props.customStyle,
            isDisabled: isDisabled
          }));
        } else {
          days.push((0, _rax.createElement)(_Day.default, {
            key: "".concat(renderIndex),
            filler: true
          }));
        }

        if (renderIndex % 7 === 6) {
          weekRows.push((0, _rax.createElement)(_raxView.default, {
            key: weekRows.length,
            style: [_styles.default.weekRow, _this2.props.customStyle.weekRow]
          }, days));
          days = [];

          if (dayIndex + 1 >= argMonthDaysCount) {
            return "break";
          }
        }

        renderIndex += 1;
      };

      do {
        var _ret = _loop();

        if (_ret === "break") break;
      } while (true);

      return (0, _rax.createElement)(_raxView.default, {
        key: argMoment.month(),
        style: _styles.default.monthContainer
      }, weekRows);
    }
  }, {
    key: "renderHeading",
    value: function renderHeading() {
      var headings = [];

      for (var i = 0; i < 7; i++) {
        var j = (i + this.props.weekStart) % 7;
        headings.push((0, _rax.createElement)(_raxText.default, {
          key: i,
          style: j === 0 || j === 6 ? [_styles.default.weekendHeading, this.props.customStyle.weekendHeading] : [_styles.default.dayHeading, this.props.customStyle.dayHeading]
        }, this.props.dayHeadings[j]));
      }

      return (0, _rax.createElement)(_raxView.default, {
        style: [_styles.default.calendarHeading, this.props.customStyle.calendarHeading]
      }, headings);
    }
  }, {
    key: "renderTopBar",
    value: function renderTopBar() {
      return this.props.showControls ? (0, _rax.createElement)(_raxView.default, {
        style: [_styles.default.calendarControls, this.props.customStyle.calendarControls]
      }, (0, _rax.createElement)(_raxTouchable.default, {
        style: [_styles.default.controlButton, this.props.customStyle.controlButton],
        onPress: this.onPrev
      }, (0, _rax.createElement)(_raxText.default, {
        style: [_styles.default.controlButtonText, this.props.customStyle.controlButtonText]
      }, this.props.prevButtonText)), (0, _rax.createElement)(_raxText.default, {
        style: [_styles.default.title, this.props.customStyle.title]
      }, this.state.currentMonthMoment.format(this.props.titleFormat)), (0, _rax.createElement)(_raxTouchable.default, {
        style: [_styles.default.controlButton, this.props.customStyle.controlButton],
        onPress: this.onNext
      }, (0, _rax.createElement)(_raxText.default, {
        style: [_styles.default.controlButtonText, this.props.customStyle.controlButtonText]
      }, this.props.nextButtonText))) : (0, _rax.createElement)(_raxView.default, {
        style: [_styles.default.calendarControls, this.props.customStyle.calendarControls]
      }, (0, _rax.createElement)(_raxText.default, {
        style: [_styles.default.title, this.props.customStyle.title]
      }, this.state.currentMonthMoment.format(this.props.titleFormat)));
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var calendarDates = this.getMonthStack(this.state.currentMonthMoment);
      var eventDatesMap = this.prepareEventDates(this.props.eventDates);
      var calendarDatesNode = calendarDates.map(function (date) {
        return _this3.renderMonthView((0, _moment.default)(date), eventDatesMap);
      });
      return (0, _rax.createElement)(_raxView.default, {
        style: [_styles.default.calendarContainer, this.props.customStyle.calendarContainer]
      }, this.renderTopBar(), this.props.showDayHeadings && this.renderHeading(this.props.titleFormat), (0, _rax.createElement)(_raxView.default, {
        style: {
          height: calendarDatesNode[0].props.children.length * 92
        }
      }, calendarDatesNode));
    }
  }]);

  return Calendar;
}(_rax.Component);

exports.default = Calendar;

_defineProperty(Calendar, "propTypes", {
  customStyle: _rax.PropTypes.object,
  dayHeadings: _rax.PropTypes.array,
  eventDates: _rax.PropTypes.array,
  monthNames: _rax.PropTypes.array,
  nextButtonText: _rax.PropTypes.string,
  onDateSelect: _rax.PropTypes.func,
  onSwipeNext: _rax.PropTypes.func,
  onSwipePrev: _rax.PropTypes.func,
  onTouchNext: _rax.PropTypes.func,
  onTouchPrev: _rax.PropTypes.func,
  prevButtonText: _rax.PropTypes.string,
  selectedDate: _rax.PropTypes.any,
  showControls: _rax.PropTypes.bool,
  startDate: _rax.PropTypes.any,
  endDate: _rax.PropTypes.any,
  titleFormat: _rax.PropTypes.string,
  dateFormat: _rax.PropTypes.string,
  today: _rax.PropTypes.any,
  weekStart: _rax.PropTypes.number
});

_defineProperty(Calendar, "defaultProps", {
  customStyle: {},
  dayHeadings: ['S', 'M', 'T', 'W', 'T', 'F', 'S'],
  eventDates: [],
  monthNames: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
  nextButtonText: 'Next',
  prevButtonText: 'Prev',
  showControls: true,
  titleFormat: 'MMMM YYYY',
  dateFormat: 'YYYY-MM-DD',
  today: (0, _moment.default)(),
  weekStart: 1
});

module.exports = exports["default"];